#!/usr/bin/env python
import sys

def test(filename):
    import hmm.tr_obj as tr_obj
    import hmm.HMM_IO as HMM_IO
    import hmm.algo_HMM as algo_HMM

    pset=open(filename).readlines()

    # read all proteins
    trobjlist=[]
    for protname in pset:
        pathio='./io/'
        print protname.strip()+".io"
        prot=open(pathio+protname.strip()+".io").readlines()
        seq=[]
        labels=[]
        for line in prot:
            v=line.split()
            list=[float(x) for x in v[:-1]]
            slist=sum(list)
            if slist >0:
                list=[x/slist for x in list]
            else:
                list=[1.0/len(list) for x in list]
            seq.append(list)
            labels.append(v[-1].lower())
        trobjlist.append(tr_obj.TR_OBJ(seq,labels,name=protname.strip())) 

    hmm=HMM_IO.Build_HMM('init.mod').get_HMM()
    algo_HMM.Baum_Welch(hmm,trobjlist,Scale='Yes',labels='Yes',maxcycles=50,tolerance=10e-6,pseudoC=0.1,verbose=None)
    hmm.write_for_humans(filename+'.R.mod1')
    algo_HMM.discriminative(hmm,trobjlist,Scale='Yes',maxcycles=50,tolerance=0.002,pseudoC=0.01,Riis='Yes',eta=0.005,verbose=None)
    hmm.write_for_humans(filename+'.R.modDR')


if __name__ == '__main__':
    if len(sys.argv)<2:
        print "usage :",sys.argv[0]," proteinset"
        sys.exit(-1)
    test(sys.argv[1])
